Index: /trunk/src/org/apollo/gui/FrameRenderPasses.java
===================================================================
--- /trunk/src/org/apollo/gui/FrameRenderPasses.java	(revision 1101)
+++ /trunk/src/org/apollo/gui/FrameRenderPasses.java	(revision 1102)
@@ -1,16 +1,7 @@
 package org.apollo.gui;
 
-import java.awt.Color;
-import java.awt.FontMetrics;
-import java.awt.Graphics;
-import java.awt.Graphics2D;
-import java.awt.Rectangle;
-import java.awt.Stroke;
-import java.awt.geom.Area;
-import java.awt.geom.Rectangle2D;
 import java.util.LinkedList;
 
-import org.apollo.AudioFrameKeyboardActions;
-import org.apollo.AudioFrameMouseActions;
+import org.apollo.ApolloGestureActions;
 import org.apollo.audio.util.Timeline;
 import org.apollo.items.FramePlaybackLauncher;
@@ -19,11 +10,23 @@
 import org.apollo.widgets.LinkedTrack;
 import org.apollo.widgets.SampledTrack;
+import org.expeditee.core.Clip;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Fill;
+import org.expeditee.core.Point;
+import org.expeditee.core.Stroke;
+import org.expeditee.core.TextLayout;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gio.input.KBMInputEvent.Key;
+import org.expeditee.gio.input.StandardInputEventListeners;
 import org.expeditee.gui.Browser;
 import org.expeditee.gui.FrameGraphics;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FreeItems;
 import org.expeditee.gui.FrameGraphics.FrameRenderPass;
 import org.expeditee.items.Item;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.WidgetCorner;
 import org.expeditee.items.widgets.WidgetEdge;
@@ -31,5 +34,5 @@
 /**
  * All final effects rendered here - to give extra feedback to the user and simply to make
- * it more apealing.
+ * it more appealing.
  * @author Brook Novak
  *
@@ -37,6 +40,6 @@
 public class FrameRenderPasses implements FrameRenderPass {
 	
-	private static final Color SHADED_EXPANDED_BACKING_COLOR = new Color(80, 80, 80, 140);
-	private static final Color Y_HELPER_LINES_COLOR = Color.DARK_GRAY;
+	private static final Colour SHADED_EXPANDED_BACKING_COLOR = Colour.FromRGBA255(80, 80, 80, 140);
+	private static final Colour Y_HELPER_LINES_COLOR = Colour.DARK_GREY;
 	private static final Stroke Y_HELPER_LINES_STROKE = OverdubbedFrameTimeAxis.TRACK_TIMELINE_STROKE;
 	
@@ -48,15 +51,21 @@
 	private boolean shouldDrawFullscreenHelpers = false;
 	
-	private FrameRenderPasses() {
+	private FrameRenderPasses()
+	{
 		FrameGraphics.addFrameRenderPass(this);
 	}
 	
-	public static FrameRenderPasses getInstance() {
+	public static FrameRenderPasses getInstance()
+	{
 		return instance;
 	}
 
-	public void paintFinalPass(Graphics g) {
+	public void paintFinalPass()
+	{
 		if (Browser._theBrowser == null) return;
-		int frameHeight = Browser._theBrowser.getContentPane().getHeight();
+		
+		GraphicsManager gm = EcosystemManager.getGraphicsManager();
+		
+		int frameHeight = EcosystemManager.getGraphicsManager().getWindowSize().getHeight();
 		if (ExpandedTrackManager.getInstance().isAnyExpandedTrackVisible()
 				&& !FreeItems.getInstance().isEmpty()) {
@@ -67,5 +76,5 @@
 			for (Item i : FreeItems.getInstance()) {
 				if (i instanceof WidgetCorner) {
-					InteractiveWidget iw = ((WidgetCorner)i).getWidgetSource();
+					Widget iw = ((WidgetCorner)i).getWidgetSource();
 					
 					if (iw != null && iw instanceof SampledTrack) {
@@ -84,8 +93,7 @@
 			if (toPaint != null) {
 				for (SampledTrack trackWidget : toPaint) {
-					if (g.getClip() == null
-							|| g.getClip().intersects(trackWidget.getComponant().getBounds()))
-					trackWidget.paintInFreeSpace(g, true);
-					
+					if (gm.peekClip() == null || gm.peekClip().isNotClipped() || (!gm.peekClip().isFullyClipped() && gm.peekClip().getBounds().intersects(trackWidget.getBounds()))) {
+						trackWidget.paintInFreeSpace(true);
+					}
 				}
 			}
@@ -93,26 +101,24 @@
 		} 
 		
-		OverdubbedFrameTimeAxis.getInstance().paint(g);
+		OverdubbedFrameTimeAxis.getInstance().paint();
 		
 		TimeAxis timeAxis = OverdubbedFrameTimeAxis.getInstance().getTimeAxis();	
 		Timeline lastTimeline = OverdubbedFrameTimeAxis.getInstance().getLastTimeline();
 		
-		FramePlaybackBarRenderer.getInstance().paint((Graphics2D)g);
+		FramePlaybackBarRenderer.getInstance().paint();
 
 		if (timeHelperLinesToPaint != null && timeAxis != null && lastTimeline != null) {
 
-			Rectangle r = OverdubbedFrameTimeAxis.getInstance().getCurrentTimelineArea();
+			AxisAlignedBoxBounds r = OverdubbedFrameTimeAxis.getInstance().getCurrentTimelineArea();
 			
 			// Draw helper bar and text
 			for (Integer x : timeHelperLinesToPaint) {
 				
-				((Graphics2D)g).setStroke(OverdubbedFrameTimeAxis.TRACK_TIMELINE_STROKE);
-				g.setColor(Color.RED);
-				
-				if (shouldDrawFullscreenHelpers) 
-					g.drawLine(x, 0, x, frameHeight);
-				else 
-					g.drawLine(x, r.y, x, r.y + r.height);
-									
+				if (shouldDrawFullscreenHelpers) {
+					gm.drawLine(new Point(x, 0), new Point(x, frameHeight), Colour.RED, OverdubbedFrameTimeAxis.TRACK_TIMELINE_STROKE);
+				} else {
+					gm.drawLine(new Point(x, r.getMinY()), new Point(x, r.getMinY() + r.getHeight()), Colour.RED, OverdubbedFrameTimeAxis.TRACK_TIMELINE_STROKE);
+				}
+				
 				long ms = lastTimeline.getMSTimeAtX(x) - lastTimeline.getFirstInitiationTime();
 
@@ -120,24 +126,16 @@
 				if (ms < 0) label = "-" + label;
 				
-				FontMetrics fm   = g.getFontMetrics(SampledTrackGraphViewPort.TIME_HELPER_FONT);
-				Rectangle2D rect = fm.getStringBounds(label, g);
+				//FontMetrics fm   = g.getFontMetrics(SampledTrackGraphViewPort.TIME_HELPER_FONT);
+				//Rectangle2D rect = fm.getStringBounds(label, g);
+				TextLayout layout = EcosystemManager.getTextLayoutManager().layoutStringSimple(label, SampledTrackGraphViewPort.TIME_HELPER_FONT);
+				AxisAlignedBoxBounds rect = layout.getPixelBounds(0, 0);
 				int labelWidth  = (int)(rect.getWidth());
 				int labelHeight  = (int)(rect.getHeight());
 				
-				int y = r.y + (r.height / 2) - ((labelHeight + 4) / 2);
-				
-
-				g.setColor(SampledTrackGraphViewPort.TIME_HELPER_COLOR);
-				g.fillRect(x + 2,  y, labelWidth + 3, labelHeight + 4);
-	
-				g.setColor(SampledTrackGraphViewPort.TIME_HELPER_BORDERCOLOR);
-				((Graphics2D)g).setStroke(SampledTrackGraphViewPort.ZOOM_BACKING_BORDER_STROKE);
-				g.fillRect(x + 2,  y, labelWidth + 3, labelHeight + 4);
-
-				g.setFont(SampledTrackGraphViewPort.TIME_HELPER_FONT);
-				g.setColor(Color.BLACK);
-				g.drawString(label, x + 4, y + labelHeight);
-				
-				
+				int y = r.getMinY() + (r.getHeight() / 2) - ((labelHeight + 4) / 2);
+				
+				gm.drawRectangle(new Point(x + 2,  y), new Dimension(labelWidth + 3, labelHeight + 4), 0.0, new Fill(SampledTrackGraphViewPort.TIME_HELPER_COLOR), SampledTrackGraphViewPort.TIME_HELPER_BORDERCOLOR, SampledTrackGraphViewPort.ZOOM_BACKING_BORDER_STROKE, null);
+
+				gm.drawTextLayout(layout, new Point(x + 4, y + labelHeight), Colour.BLACK);
 			}
 		
@@ -146,36 +144,26 @@
 //		 Draw Y helper
 		if (yAxisTimelineHelperToPaint != null) {
-
-			((Graphics2D)g).setStroke(Y_HELPER_LINES_STROKE);
-			g.setColor(Y_HELPER_LINES_COLOR);
-
-			g.drawLine(
-					0, 
-					yAxisTimelineHelperToPaint.value, 
-					Browser._theBrowser.getContentPane().getWidth(), 
-					yAxisTimelineHelperToPaint.value);
-			
-		}
-		
-	
-	}
-
-	public void paintPreLayeredPanePass(Graphics g) {
+			gm.drawLine(0, yAxisTimelineHelperToPaint.value, EcosystemManager.getGraphicsManager().getWindowSize().getWidth(), yAxisTimelineHelperToPaint.value, Y_HELPER_LINES_COLOR, Y_HELPER_LINES_STROKE);
+		}
+		
+	
+	}
+
+	public void paintPreLayeredPanePass()
+	{
 		if (Browser._theBrowser == null) return;
 		
 		if (ExpandedTrackManager.getInstance().isAnyExpandedTrackVisible()) {
-			
-			g.setColor(SHADED_EXPANDED_BACKING_COLOR);
-			g.fillRect(0, 0, 
-					Browser._theBrowser.getContentPane().getWidth(), 
-					Browser._theBrowser.getContentPane().getHeight());
-		}
-		
-	}
-
-	public Area paintStarted(Area currentClip) {
+			Dimension windowSize = EcosystemManager.getGraphicsManager().getWindowSize();
+			EcosystemManager.getGraphicsManager().drawRectangle(Point.ORIGIN, windowSize, 0.0, new Fill(SHADED_EXPANDED_BACKING_COLOR), null, null, null);
+		}
+		
+	}
+
+	public Clip paintStarted(Clip currentClip)
+	{
 		if (Browser._theBrowser == null) return currentClip;
 
-		LinkedList<InteractiveWidget> seen = null;
+		LinkedList<Widget> seen = null;
 		
 		//boolean idDirty = false;
@@ -189,18 +177,18 @@
 		timeHelperLinesToPaint = null;
 		yAxisTimelineHelperToPaint = null;
-		shouldDrawFullscreenHelpers = AudioFrameKeyboardActions.isControlDown() || 
-			(AudioFrameKeyboardActions.isShiftDown() && !FreeItems.getInstance().isEmpty());
+		shouldDrawFullscreenHelpers = StandardInputEventListeners.kbmStateListener.isKeyDown(Key.CTRL) || 
+			(StandardInputEventListeners.kbmStateListener.isKeyDown(Key.SHIFT) && !FreeItems.getInstance().isEmpty());
 
 		// Get free tracks and paint line helpers
-		if (!FreeItems.getInstance().isEmpty() || FrameMouseActions.getlastHighlightedItem() != null) {
+		if (!FreeItems.getInstance().isEmpty() || StandardGestureActions.getlastHighlightedItem() != null) {
 
 			LinkedList<Item> possibles = new LinkedList<Item>(FreeItems.getInstance());
-			if (FreeItems.getInstance().isEmpty() &&
-					FrameMouseActions.getlastHighlightedItem() != null)
-				possibles.add(FrameMouseActions.getlastHighlightedItem());
+			if (FreeItems.getInstance().isEmpty() && StandardGestureActions.getlastHighlightedItem() != null) {
+				possibles.add(StandardGestureActions.getlastHighlightedItem());
+			}
 			
 			for (Item i : possibles) {
 				
-				InteractiveWidget iw = null;
+				Widget iw = null;
 				
 				if (i instanceof WidgetCorner) {
@@ -216,5 +204,5 @@
 						
 						if (seen == null) {
-							seen = new LinkedList<InteractiveWidget>();
+							seen = new LinkedList<Widget>();
 						} else if (seen.contains(iw)) {
 							continue;
@@ -235,5 +223,5 @@
 		} 
 		
-		if ((AudioFrameMouseActions.isYAxisRestictionOn() || AudioFrameMouseActions.isSnapOn()) 
+		if ((ApolloGestureActions.isYAxisRestictionOn() || ApolloGestureActions.isSnapOn()) 
 			&& !FreeItems.getInstance().isEmpty()) {
 			
@@ -255,31 +243,27 @@
 	}
 	
-	private void invalidateHelperLines(Area currentClip) {
-		if (currentClip != null) {
-			
-			if (timeHelperLinesToPaint != null && !timeHelperLinesToPaint.isEmpty()) {
-				currentClip.add(new Area(OverdubbedFrameTimeAxis.getInstance().getCurrentTimelineArea()));
-				if (shouldDrawFullscreenHelpers) {
-					int fsHeight = Browser._theBrowser.getContentPane().getHeight();
-					for (Integer n : timeHelperLinesToPaint) {
-						currentClip.add(new Area(new Rectangle(n - 1, 0, 3, fsHeight)));
-					}
-				}
-			}
-			
-			if (yAxisTimelineHelperToPaint != null && shouldDrawFullscreenHelpers) {
-
-				currentClip.add(new Area(new Rectangle(
-						0, 
-						yAxisTimelineHelperToPaint.value - 1, 
-						Browser._theBrowser.getContentPane().getWidth(), 
-						3)));
-			
-			}
-		}
-	}
-	
-	
-	
-
+	private void invalidateHelperLines(Clip currentClip)
+	{
+		if (currentClip == null) return;
+		
+		if (timeHelperLinesToPaint != null && !timeHelperLinesToPaint.isEmpty()) {
+			currentClip.includeBounds(OverdubbedFrameTimeAxis.getInstance().getCurrentTimelineArea().clone());
+			if (shouldDrawFullscreenHelpers) {
+				int fsHeight = EcosystemManager.getGraphicsManager().getWindowSize().getHeight();
+				for (Integer n : timeHelperLinesToPaint) {
+					currentClip.includeBounds(new AxisAlignedBoxBounds(n - 1, 0, 3, fsHeight));
+				}
+			}
+		}
+		
+		if (yAxisTimelineHelperToPaint != null && shouldDrawFullscreenHelpers) {
+
+			currentClip.includeBounds(new AxisAlignedBoxBounds(
+					0, 
+					yAxisTimelineHelperToPaint.value - 1, 
+					EcosystemManager.getGraphicsManager().getWindowSize().getWidth(), 
+					3));
+		
+		}
+	}
 }
Index: /trunk/src/org/apollo/gui/OverdubbedFrameTimeAxis.java
===================================================================
--- /trunk/src/org/apollo/gui/OverdubbedFrameTimeAxis.java	(revision 1101)
+++ /trunk/src/org/apollo/gui/OverdubbedFrameTimeAxis.java	(revision 1102)
@@ -1,14 +1,3 @@
 package org.apollo.gui;
-
-import java.awt.BasicStroke;
-import java.awt.Color;
-import java.awt.Graphics;
-import java.awt.Graphics2D;
-import java.awt.Rectangle;
-import java.awt.Stroke;
-import java.awt.event.ComponentEvent;
-import java.awt.event.ComponentListener;
-
-import javax.swing.SwingUtilities;
 
 import org.apollo.audio.util.Timeline;
@@ -16,8 +5,16 @@
 import org.apollo.mvc.Subject;
 import org.apollo.mvc.SubjectChangedEvent;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Fill;
+import org.expeditee.core.Point;
+import org.expeditee.core.Stroke;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gio.InputManager.WindowEventListener;
+import org.expeditee.gio.InputManager.WindowEventType;
 import org.expeditee.gui.Browser;
-import org.expeditee.gui.DisplayIO;
-import org.expeditee.gui.FrameGraphics;
-import org.expeditee.gui.MessageBay;
+import org.expeditee.gui.DisplayController;
 
 /**
@@ -30,5 +27,5 @@
 
 	private TimeAxis timeAxis = null;
-	private Rectangle lastInvalidated;
+	private AxisAlignedBoxBounds lastInvalidated;
 	private Timeline lastTimeline = null;
 
@@ -36,11 +33,10 @@
 
 	private static final int GLOBAL_TIMELINE_HEIGHT = 30;
-	private static final Color GLOBAL_TIMELINE_BACKCOLOR = new Color(220, 220, 220, 100);
-	private static final Color GLOBAL_EMPTY_TIMELINE_BACKCOLOR = new Color(240, 240, 240, 100);
+	private static final Colour GLOBAL_TIMELINE_BACKCOLOR = Colour.FromRGBA255(220, 220, 220, 100);
+	private static final Colour GLOBAL_EMPTY_TIMELINE_BACKCOLOR = Colour.FromRGBA255(240, 240, 240, 100);
 	
-	public static final Stroke TRACK_TIMELINE_STROKE = new BasicStroke(
-			1.0f, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_BEVEL, 0.0f, new float[] { 5.0f, 5.0f }, 0.0f);
+	public static final Stroke TRACK_TIMELINE_STROKE = new Stroke(1.0f, Stroke.CAP.SQUARE, Stroke.JOIN.BEVEL, new float[] { 5.0f, 5.0f }, 0.0f);
 	
-	private static final Stroke TIMELINE_BORDER_STROKE = new BasicStroke(1.0f);
+	private static final Stroke TIMELINE_BORDER_STROKE = new Stroke(1.0f);
 			
 	/**
@@ -54,27 +50,10 @@
 		
 		// Listen for resize events
-		SwingUtilities.invokeLater(new Runnable() {
-			public void run() {
-
-				// Keep expanded view centered to the browser window
-				if (Browser._theBrowser != null) {
-					Browser._theBrowser.addComponentListener(new ComponentListener() {
-
-						public void componentHidden(ComponentEvent e) {
-						}
-
-						public void componentMoved(ComponentEvent e) {
-						}
-
-						public void componentResized(ComponentEvent e) {
-							updateAxis();
-						}
-
-						public void componentShown(ComponentEvent e) {
-						}
-						
-					});
-				}
-				
+		EcosystemManager.getInputManager().addWindowEventListener(new WindowEventListener()
+		{
+			@Override
+			public void onWindowEvent(WindowEventType type)
+			{
+				if (type == WindowEventType.WINDOW_RESIZED) updateAxis();
 			}
 		});
@@ -113,14 +92,14 @@
 		lastTimeline = FrameLayoutDaemon.getInstance().getLastComputedTimeline();
 		if (lastTimeline == null || 
-			FrameLayoutDaemon.getInstance().getTimelineOwner() != DisplayIO.getCurrentFrame()) {
+			FrameLayoutDaemon.getInstance().getTimelineOwner() != DisplayController.getCurrentFrame()) {
 			
 			// The frame layout daemon only lays out frames once - unless the user rearranges tracks
 			// on a frame then the daemon we re-calc the timeline... thus a timeline must be infferred
 			
-			lastTimeline = FrameLayoutDaemon.inferTimeline(DisplayIO.getCurrentFrame());
+			lastTimeline = FrameLayoutDaemon.inferTimeline(DisplayController.getCurrentFrame());
 			
 			if (lastTimeline == null) { // no widgets
 				if (timeAxis != null && lastInvalidated != null) {
-					FrameGraphics.invalidateArea(lastInvalidated); // old position
+					DisplayController.invalidateArea(lastInvalidated); // old position
 				}
 				
@@ -141,51 +120,49 @@
 
 		
-		Rectangle newBounds = getCurrentTimelineArea();
+		AxisAlignedBoxBounds newBounds = getCurrentTimelineArea();
 		if (lastInvalidated != null && !lastInvalidated.equals(newBounds)) {
-			FrameGraphics.invalidateArea(lastInvalidated); // old position
+			DisplayController.invalidateArea(lastInvalidated); // old position
 		}
 		
-		FrameGraphics.invalidateArea(newBounds);
+		DisplayController.invalidateArea(newBounds);
 		
 		lastInvalidated = newBounds;
 		
-		FrameGraphics.refresh(true);
+		DisplayController.requestRefresh(true);
 		
 	}
 
-	public Rectangle getCurrentTimelineArea() {
+	public AxisAlignedBoxBounds getCurrentTimelineArea()
+	{
 		assert(Browser._theBrowser != null);
-		int y = Browser._theBrowser.getContentPane().getHeight() - GLOBAL_TIMELINE_HEIGHT;
-		if (!FrameGraphics.isAudienceMode()) {
-			y -= MessageBay.MESSAGE_BUFFER_HEIGHT;
+		int y = EcosystemManager.getGraphicsManager().getWindowSize().getHeight() - GLOBAL_TIMELINE_HEIGHT;
+		if (!DisplayController.isAudienceMode()) {
+			y -= DisplayController.getMessageBayPaintArea().getHeight();
 		}
 		
 		if (y < 0) y = 0;
 
-		return new Rectangle(0, y, Browser._theBrowser.getContentPane().getWidth(), GLOBAL_TIMELINE_HEIGHT);
+		return new AxisAlignedBoxBounds(0, y, EcosystemManager.getGraphicsManager().getWindowSize().getWidth(), GLOBAL_TIMELINE_HEIGHT);
 	}
 	
 
-	public void paint(Graphics g) {
+	public void paint()
+	{
 		if (Browser._theBrowser == null) return;
 
 		if (timeAxis != null && lastTimeline != null) {
 		
-			Rectangle r = getCurrentTimelineArea();
-
-			g.setColor(GLOBAL_EMPTY_TIMELINE_BACKCOLOR);
-			g.fillRect(0, r.y, Browser._theBrowser.getContentPane().getWidth(), r.height);
+			GraphicsManager gm = EcosystemManager.getGraphicsManager();
 			
-			timeAxis.paint(g, 
+			AxisAlignedBoxBounds r = getCurrentTimelineArea();
+			gm.drawRectangle(new Point(0, r.getMinY()), new Dimension(EcosystemManager.getGraphicsManager().getWindowSize().getWidth(), r.getHeight()), 0.0, new Fill(GLOBAL_EMPTY_TIMELINE_BACKCOLOR), null, null, null);
+			
+			timeAxis.paint( 
 					lastTimeline.getInitiationXPixel(),
-					r.y,
-					r.height, 
+					r.getMinY(),
+					r.getHeight(), 
 					GLOBAL_TIMELINE_BACKCOLOR);
 			
-			
-			g.setColor(Color.DARK_GRAY);
-			
-			((Graphics2D)g).setStroke(TIMELINE_BORDER_STROKE);
-			g.drawLine(0, r.y, Browser._theBrowser.getContentPane().getWidth(), r.y);
+			gm.drawLine(new Point(0, r.getMinY()), new Point(EcosystemManager.getGraphicsManager().getWindowSize().getWidth(), r.getMinY()), Colour.DARK_GREY, TIMELINE_BORDER_STROKE);
 	
 		}
Index: /trunk/src/org/apollo/gui/PlaybackControlPopup.java
===================================================================
--- /trunk/src/org/apollo/gui/PlaybackControlPopup.java	(revision 1101)
+++ /trunk/src/org/apollo/gui/PlaybackControlPopup.java	(revision 1102)
@@ -2,4 +2,5 @@
 
 import java.awt.Dimension;
+import java.awt.Graphics2D;
 import java.awt.GridBagConstraints;
 import java.awt.GridBagLayout;
@@ -8,6 +9,6 @@
 import java.awt.event.ActionListener;
 
-import javax.swing.Icon;
 import javax.swing.JButton;
+import javax.swing.JPanel;
 import javax.swing.JSlider;
 import javax.swing.JToggleButton;
@@ -16,5 +17,10 @@
 
 import org.apollo.io.IconRepository;
+import org.expeditee.core.Image;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gio.swing.SwingMiscManager;
 import org.expeditee.gui.Popup;
+import org.expeditee.gui.PopupManager.ExpandShrinkAnimator;
 
 /**
@@ -25,6 +31,7 @@
  *
  */
-public abstract class PlaybackControlPopup extends Popup implements ActionListener {
-
+public abstract class PlaybackControlPopup extends Popup implements ActionListener
+{
+	public JPanel panel;
 	public JButton playPauseButton;
 	public JButton stopButton;
@@ -39,11 +46,14 @@
 	private static final int BUTTON_SIZE = 40;
 	
-	protected PlaybackControlPopup() {
-		super(new GridBagLayout());
+	protected PlaybackControlPopup()
+	{
+		super(new ExpandShrinkAnimator());
+		
+		panel = new JPanel(new GridBagLayout());
 		
 		playPauseButton = new JButton();
 		playPauseButton.setActionCommand("playpause");
 		playPauseButton.addActionListener(this);
-		playPauseButton.setIcon(IconRepository.getIcon("play.png"));
+		SwingMiscManager.setJButtonIcon(playPauseButton, IconRepository.getIcon("play.png"));
 		playPauseButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		playPauseButton.setToolTipText("Play selection / Pause");
@@ -53,5 +63,5 @@
 		stopButton.addActionListener(this);
 		stopButton.setActionCommand("stop");
-		stopButton.setIcon(IconRepository.getIcon("stop.png"));
+		SwingMiscManager.setJButtonIcon(stopButton, IconRepository.getIcon("stop.png"));
 		stopButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		stopButton.setToolTipText("Stop playback");
@@ -60,5 +70,5 @@
 		rewindButton.addActionListener(this);
 		rewindButton.setActionCommand("rewind");
-		rewindButton.setIcon(IconRepository.getIcon("rewind.png"));
+		SwingMiscManager.setJButtonIcon(rewindButton, IconRepository.getIcon("rewind.png"));
 		rewindButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		rewindButton.setToolTipText("Rewind to start");
@@ -66,5 +76,5 @@
 		// Icon changes
 		muteButton = new JToggleButton();
-		muteButton.setSelectedIcon(IconRepository.getIcon("volmute.png"));
+		SwingMiscManager.setJButtonSelectedIcon(muteButton, IconRepository.getIcon("volmute.png"));
 		muteButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		muteButton.setToolTipText("Toggle mute");
@@ -78,6 +88,6 @@
 		
 		soloButton = new JToggleButton();
-		soloButton.setIcon(IconRepository.getIcon("solo.png"));
-		soloButton.setSelectedIcon(IconRepository.getIcon("soloon.png"));
+		SwingMiscManager.setJButtonIcon(soloButton, IconRepository.getIcon("solo.png"));
+		SwingMiscManager.setJButtonSelectedIcon(soloButton, IconRepository.getIcon("soloon.png"));
 		soloButton.setPreferredSize(new Dimension(BUTTON_SIZE, BUTTON_SIZE));
 		soloButton.setToolTipText("Toggle solo");
@@ -115,5 +125,5 @@
 		c.gridy = 0;
 		c.fill = GridBagConstraints.BOTH;
-		add(playPauseButton, c);
+		panel.add(playPauseButton, c);
 		
 		c = new GridBagConstraints();
@@ -121,5 +131,5 @@
 		c.gridy = 0;
 		c.fill = GridBagConstraints.BOTH;
-		add(stopButton, c);
+		panel.add(stopButton, c);
 		
 		c = new GridBagConstraints();
@@ -127,5 +137,5 @@
 		c.gridy = 0;
 		c.fill = GridBagConstraints.BOTH;
-		add(rewindButton, c);
+		panel.add(rewindButton, c);
 		
 		c = new GridBagConstraints();
@@ -133,5 +143,5 @@
 		c.gridy = 0;
 		c.fill = GridBagConstraints.BOTH;
-		add(soloButton, c);
+		panel.add(soloButton, c);
 		
 		c = new GridBagConstraints();
@@ -139,5 +149,5 @@
 		c.gridy = 0;
 		c.fill = GridBagConstraints.BOTH;
-		add(muteButton, c);
+		panel.add(muteButton, c);
 		
 		c = new GridBagConstraints();
@@ -146,5 +156,5 @@
 		c.fill = GridBagConstraints.BOTH;
 		c.insets = new Insets(0,VOLUME_SPACING,0,VOLUME_SPACING);
-		add(volumeSlider, c);
+		panel.add(volumeSlider, c);
 		
 		c = new GridBagConstraints();
@@ -152,5 +162,5 @@
 		c.gridy = 0;
 		c.fill = GridBagConstraints.BOTH;
-		add(miscButton, c);
+		panel.add(miscButton, c);
 		
 //
@@ -201,7 +211,7 @@
 //		this.setSize(BUTTON_SIZE * 4, BUTTON_SIZE * 2);
 		
-		this.setSize(BUTTON_SIZE * 8, BUTTON_SIZE);
-		
-		this.doLayout();
+		panel.setSize(BUTTON_SIZE * 8, BUTTON_SIZE);
+		
+		panel.doLayout();
 		
 	}
@@ -213,5 +223,5 @@
 	private void updateButtonGUI() {
 		
-		Icon newIcon = null;
+		Image newIcon = null;
 		if (volumeSlider.getValue() <= 25) 
 				newIcon = IconRepository.getIcon("vol25.png");
@@ -223,8 +233,24 @@
 				newIcon = IconRepository.getIcon("vol100.png");
 		
-		muteButton.setIcon(newIcon);
-	}
-
-
+		SwingMiscManager.setJButtonIcon(muteButton, newIcon);
+	}
+	
+	@Override
+	protected void paintInternal()
+	{
+		Graphics2D g = SwingMiscManager.getIfUsingSwingGraphicsManager().getCurrentSurface();
+		AxisAlignedBoxBounds bounds = getBounds();
+		
+		g.translate(bounds.getMinX(), bounds.getMinY());
+		panel.paint(g);
+		g.translate(-bounds.getMinX(), -bounds.getMinY());
+	}
+
+	@Override
+	public AxisAlignedBoxBounds getFullBounds()
+	{
+		return SwingConversions.fromSwingRectangle(panel.getBounds());
+	}
+	
 	public abstract void actionPerformed(ActionEvent e);
 	
Index: /trunk/src/org/apollo/gui/SampledTrackGraphView.java
===================================================================
--- /trunk/src/org/apollo/gui/SampledTrackGraphView.java	(revision 1101)
+++ /trunk/src/org/apollo/gui/SampledTrackGraphView.java	(revision 1102)
@@ -1,4 +1,5 @@
 package org.apollo.gui;
 
+import java.awt.BasicStroke;
 import java.awt.Color;
 import java.awt.Event;
@@ -10,8 +11,6 @@
 import java.awt.Point;
 import java.awt.Rectangle;
-import java.awt.Stroke;
 import java.awt.event.ComponentEvent;
 import java.awt.event.ComponentListener;
-import java.awt.image.BufferedImage;
 import java.util.LinkedList;
 import java.util.List;
@@ -31,6 +30,10 @@
 import org.apollo.mvc.Subject;
 import org.apollo.mvc.SubjectChangedEvent;
+import org.expeditee.core.Image;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.swing.SwingConversions;
+import org.expeditee.gio.swing.SwingMiscManager;
 import org.expeditee.gui.Browser;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.DisplayController;
 
 /**
@@ -59,5 +62,5 @@
 
 	private WaveFormRenderProccessingUnit.WaveFormRenderTask renderTask = null;
-	private BufferedImage backBuffer = null; // Shared resource
+	private Image backBuffer = null; // Shared resource
 	private int bufferWidth = -1; // cached from backBuffer - so don't have to lock
 	private int bufferHeight = -1; // cached from backBuffer - so don't have to lock
@@ -67,5 +70,5 @@
 	private int timescaleFrameLength = 0; // in frames
 	
-	private final Font RENDER_MESSAGE_FONT = new Font("Arial", Font.ITALIC | Font.BOLD, 14);
+	private final Font RENDER_MESSAGE_FONT = new Font("Arial", Font.BOLD | Font.ITALIC, 14);
 	
 	private boolean alwaysFullViewOn = false;
@@ -80,5 +83,5 @@
 	
 	/** The stroke used for drawing graph bars. E.G: The selection Start bar. */
-	public static final Stroke GRAPH_BAR_STROKE = Strokes.SOLID_1;
+	public static final BasicStroke GRAPH_BAR_STROKE = SwingConversions.toSwingStroke(Strokes.SOLID_1);
 	public static final int GRAPH_BAR_NWIDTH = 1;
 	
@@ -139,5 +142,5 @@
 				this, 
 				0, 0, 
-				Browser._theBrowser.getContentPane());
+				SwingMiscManager.getIfUsingSwingGraphicsManager().getContentPane());
 	}
 	
@@ -339,5 +342,5 @@
 				
 				if (x >= 0 && x <= viewWidth) { // is the playback position in view?
-					FrameGraphics.invalidateArea(new Rectangle(
+					DisplayController.invalidateArea(new AxisAlignedBoxBounds(
 						x + expediteePosition.x, 
 						expediteePosition.y, 
@@ -356,5 +359,5 @@
 				
 				if (x >= 0 && x <= viewWidth) { // is the playback position in view?
-					FrameGraphics.invalidateArea(new Rectangle(
+					DisplayController.invalidateArea(new AxisAlignedBoxBounds(
 						x + expediteePosition.x , 
 						expediteePosition.y, 
@@ -565,5 +568,5 @@
 		
 		renderTask = null; // must be on swing thread because could be painting
-		if (backBuffer != null) backBuffer.flush();
+		if (backBuffer != null) backBuffer.releaseImage();
 		backBuffer = null; // must be on swing thread because could be painting
 	}
@@ -605,9 +608,10 @@
 				
 				// Create new sized buffer
-				backBuffer = new BufferedImage(
+				backBuffer = Image.createImage(width, height);
+/*				backBuffer = new BufferedImage(
 						width, 
 						height,
 						BufferedImage.TYPE_BYTE_INDEXED,
-						ApolloColorIndexedModels.graphIndexColorModel);
+						ApolloColorIndexedModels.graphIndexColorModel);*/
 			}
 		}
@@ -624,5 +628,5 @@
 				);
 		
-		// Wait for invalidation recomendation messages
+		// Wait for invalidation recommendation messages
 		renderTask.addObserver(this);
 
@@ -693,9 +697,9 @@
 				synchronized(backBuffer) {
 	
-					g.drawImage(backBuffer, 
+					g.drawImage(SwingMiscManager.getIfUsingSwingImageManager().getInternalImage(backBuffer), 
 							0, 
 							0, 
 							getWidth(), 
-							getHeight(), 
+							getHeight(),
 							null);
 					
@@ -709,9 +713,9 @@
 				// No need to synchronize waveformBuffer because there is no thread accessing it,
 				// and a new render thread is always created on this thread.
-				g.drawImage(backBuffer, 
+				g.drawImage(SwingMiscManager.getIfUsingSwingImageManager().getInternalImage(backBuffer),
 						0, 
 						0, 
 						getWidth(), 
-						getHeight(), 
+						getHeight(),
 						null);
 				
@@ -919,9 +923,11 @@
 	 *
 	 */
-	public interface EffecientInvalidator {
+	public interface EffecientInvalidator
+	{
 		public void onGraphDirty(SampledTrackGraphView graph, Rectangle dirty);
 	}
 
-	public Color getBackColor() {
+	public Color getBackColor()
+	{
 		return backColor;
 	}
@@ -935,5 +941,6 @@
 	 * 	
 	 */
-	public void setBackColor(Color backColor, Color highlights) {
+	public void setBackColor(Color backColor, Color highlights)
+	{
 		setBackColor(backColor, highlights, true);
 	}
@@ -949,5 +956,6 @@
 	 * 		Doesnt invalidate if the color has not changed.
 	 */
-	public void setBackColor(Color backColor, Color highlights, boolean invalidate) {
+	public void setBackColor(Color backColor, Color highlights, boolean invalidate)
+	{
 		if (backColor == null) throw new NullPointerException("backColor");
 		if (this.backColor != backColor || backColorHighlights != highlights) {
